// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	v1 "github.com/openshift/ptp-operator/pkg/apis/ptp/v1"
	"github.com/openshift/ptp-operator/pkg/client/clientset/versioned/scheme"
	rest "k8s.io/client-go/rest"
)

type PtpV1Interface interface {
	RESTClient() rest.Interface
	NodePtpDevicesGetter
	PtpConfigsGetter
	PtpOperatorConfigsGetter
}

// PtpV1Client is used to interact with features provided by the ptp.openshift.io group.
type PtpV1Client struct {
	restClient rest.Interface
}

func (c *PtpV1Client) NodePtpDevices(namespace string) NodePtpDeviceInterface {
	return newNodePtpDevices(c, namespace)
}

func (c *PtpV1Client) PtpConfigs(namespace string) PtpConfigInterface {
	return newPtpConfigs(c, namespace)
}

func (c *PtpV1Client) PtpOperatorConfigs(namespace string) PtpOperatorConfigInterface {
	return newPtpOperatorConfigs(c, namespace)
}

// NewForConfig creates a new PtpV1Client for the given config.
func NewForConfig(c *rest.Config) (*PtpV1Client, error) {
	config := *c
	if err := setConfigDefaults(&config); err != nil {
		return nil, err
	}
	client, err := rest.RESTClientFor(&config)
	if err != nil {
		return nil, err
	}
	return &PtpV1Client{client}, nil
}

// NewForConfigOrDie creates a new PtpV1Client for the given config and
// panics if there is an error in the config.
func NewForConfigOrDie(c *rest.Config) *PtpV1Client {
	client, err := NewForConfig(c)
	if err != nil {
		panic(err)
	}
	return client
}

// New creates a new PtpV1Client for the given RESTClient.
func New(c rest.Interface) *PtpV1Client {
	return &PtpV1Client{c}
}

func setConfigDefaults(config *rest.Config) error {
	gv := v1.SchemeGroupVersion
	config.GroupVersion = &gv
	config.APIPath = "/apis"
	config.NegotiatedSerializer = scheme.Codecs.WithoutConversion()

	if config.UserAgent == "" {
		config.UserAgent = rest.DefaultKubernetesUserAgent()
	}

	return nil
}

// RESTClient returns a RESTClient that is used to communicate
// with API server by this client implementation.
func (c *PtpV1Client) RESTClient() rest.Interface {
	if c == nil {
		return nil
	}
	return c.restClient
}
